import Cache

###
### CSE 378 Spring 2010
### Homework 3
###
### Name: YOUR NAME HERE
###

MAX_BLOCK_SIZE = 64      # block size is always a power of 2
MAX_CACHE_SIZE = 2 ** 18 # cache size is always a power of 2
MAX_ASSOC = 16           # associativity is always a power of 2

def findBlockSizes( cache ):
    """Returns tuple of block sizes (in bytes) of the caches."""
    global MAX_BLOCK_SIZE
    cache.reset()
    # TODO: your code here


def findCacheSizes( cache, 
                    blockSizes    # a tuple of cache block sizes
                    ):
    """Returns tuple of total sizes (in bytes) of the caches."""
    cache.reset()
    # TODO: your code here



def findAssociativities( cache, 
                         sizes,       # a tuple of cache sizes
                         blockSizes   # a tuple of cache block sizes
                         ):
    """Returns tuple of associativities of the caches."""
    global MAX_ASSOC
    cache.reset()
    # TODO: your code here



def main(cache):
    answers = {}

    blockSizes = findBlockSizes( cache )
    answers['block sizes'] = blockSizes

    sizes = findCacheSizes( cache, blockSizes )
    answers['cache sizes'] = sizes

    answers['associativities'] = findAssociativities( cache, sizes, blockSizes )

    return answers


if __name__ == "__main__":
    # test your code by creating different caches here

    print main( Cache.Cache( bsize=2, assoc=1, size=64,                                    # direct-mapped
                             secondLevelCache=Cache.Cache( bsize=2, assoc=1, size=1024 ))) # also direct-mapped, same block size
    # output expected: {'block sizes': (2, 2), 'associativities': (1, 1), 'cache sizes': (64, 1024)}

    print main( Cache.Cache( bsize=2, assoc=4, size=8,                                     # fully-associative
                             secondLevelCache=Cache.Cache( bsize=2, assoc=1, size=1024 ))) # direct-mapped, same block size
    # output expected: {'block sizes': (2, 2), 'associativities': (4, 1), 'cache sizes': (8, 1024)}

    print main( Cache.Cache( bsize=2, assoc=1, size=64,                                    # direct-mapped
                             secondLevelCache=Cache.Cache( bsize=8, assoc=1, size=1024 ))) # direct-mapped, different block size
    # output expected: {'block sizes': (2, 8), 'associativities': (1, 1), 'cache sizes': (64, 1024)}

    print main( Cache.Cache( bsize=4, assoc=2, size=64,                                    # two-way set-associative
                             secondLevelCache=Cache.Cache( bsize=8, assoc=4, size=1024 ))) # four-way set-associative, different block size
    # output expected: {'block sizes': (4, 8), 'associativities': (2, 4), 'cache sizes': (64, 1024)}
